#include"main.h"
#include"cost_image_compression.h"
#include"gui_image_compression.h"

int main(int argc, char** argv)
{
	QApplication app(argc, argv);
	if (!QGLFormat::hasOpenGL()) {
		QMessageBox::critical(NULL, "Attention", QObject::tr("desole pas d'OpenGL !"));
		return -1;
	}
	app.setApplicationName("Image vectorization by Delaunay Point Process");
	delaunay_point_process_gui<
		Cost_vertices_ImageCompression,
		Cost_edges_ImageCompression,
		Cost_faces_ImageCompression,
		ini_data_cost_image_compression,
		gui_rendering_image_compression, glm::vec3> mon_dpp;
	mon_dpp.mainWin.resize(1024, 1024);
	mon_dpp.mainWin.show();
	//mainWin.setVisible(true);
	return app.exec();
}