#pragma once
#include<cstring>//for memcpy

class Depth_map
{
private:
	float* depth_map;
public:
	int w,h,wh;
	Depth_map():depth_map(nullptr)
	{
		
	}
	~Depth_map()
	{
		if(depth_map)
			delete[] depth_map;
	}
	Depth_map(const Depth_map& dmap):depth_map(nullptr)
	{
		w=dmap.w;
		h=dmap.h;
		wh=dmap.wh;
		if(dmap.depth_map)
		{
			depth_map = new float[wh];
			memcpy(depth_map,dmap.depth_map,wh*sizeof(float));
		}
	}
	Depth_map& operator=(const Depth_map& dmap)
	{
		w=dmap.w;
		h=dmap.h;
		wh=dmap.wh;
		if(dmap.depth_map)
		{
			depth_map = new float[wh];
			memcpy(depth_map,dmap.depth_map,wh*sizeof(float));
		}
		return *this;
	}
	void set_depth_map(float* data, int _w, int _h)
	{
		if(!depth_map)
		{
			depth_map = new float[_w*_h];
		}
		else if(w!=_w||h!=_h)
		{
			delete depth_map;
			depth_map = new float[_w*_h];
		}
		w=_w;
		h=_h;
		wh=_w*_h;
		memcpy(depth_map,data,wh*sizeof(float));
	}
	//float* const get_depth()
	float* get_depth()
	{
		return depth_map;
	}
};