#pragma once
#ifndef ___GET_COLOR____
#define ___GET_COLOR____


#include"util_define.h"
#include"get_color_from_gray.h"
//const glm::vec3& black = glm::vec3(0.0f, 0.0f, 0.0f);
inline glm::vec3 get_color()
{
	glm::vec3 tmp_color;
	do
	{
		tmp_color = glm::vec3((rand() % 1000) / 1000.0f,
			(rand() % 1000) / 1000.0f,
			(rand() % 1000) / 1000.0f);
	} while (tmp_color == glm::vec3(0, 0, 0));
	return glm::normalize(tmp_color);
}
inline std::ostringstream& _2digit(std::ostringstream& oss, const int i)
{
	if (i <= 0xF)
		oss << '0';
	oss << i;
	return oss;
}
inline std::ostringstream& _2digit(std::ostringstream& oss, const int r, const int g, const int b)
{
	return _2digit(_2digit(_2digit(oss, r), g), b);
}
inline std::string get_color_html_code()
{
	const glm::ivec3& v = glm::ivec3(get_color() * 255.0f);
	std::ostringstream oss;
	oss << '#' << std::hex;
	_2digit(oss, v.r, v.g, v.b);
	return oss.str();
}
inline std::string get_color_from_gray_html_code(float gray)
{
	const glm::ivec3& v = glm::ivec3(get_color_from_gray(gray) * 255.0f);
	std::ostringstream oss;
	oss << '#' << std::hex;
	_2digit(oss, v.r, v.g, v.b);
	return oss.str();
}
inline std::string get_color_html_code(const glm::vec3& color)
{
	const glm::ivec3& v = glm::ivec3(color * 255.0f);
	std::ostringstream oss;
	oss << '#' << std::hex;
	_2digit(oss, v.r, v.g, v.b);
	return oss.str();
}
inline std::string get_color_html_code_from_bgr(const glm::vec3& color)
{
	const glm::ivec3& v = glm::ivec3(color.b * 255.0f, color.g * 255.0f, color.r * 255.0f);
	std::ostringstream oss;
	oss << '#' << std::hex;
	_2digit(oss, v.r, v.g, v.b);
	return oss.str();
}



#endif

