#include"get_color_from_gray.h"
glm::vec3 get_color_from_gray(float val)
{
	glm::vec3 c(0,0,0);
	if(val<0)
		return c;
	if (val > 1)
	{
	//	std::cout << "color = " << val << " > 1 : BAADDD" << std::endl;
		return glm::vec3(0.9, 0.9, 0.9);
	}
	val = 2 * val - 1.0f;
	if(val<-0.75f)
	{
		c.b = 2.5f + 2.0f*val;
	}
	else if(val<-0.25f)
	{
		c.b=1.0f;
		c.g = 1.5f + 2.0f*val;
	}
	else if(val<0.25f)
	{
		c.b = 0.5f - 2.0f*val;
		c.g = 1.0f;
		c.r = 2.0f*val + 0.5f;
	}
	else if(val<0.75f)
	{
		c.g = 1.5f - 2.0f*val;
		c.r = 1.0f;
	}
	else
	{
		c.r = 2.5f - 2.0f*val;
	}
	return c;
}