#pragma once
#ifndef __HEADER___COST_APPLI_LINE_DRAWING_VECTORIZATION__
#define __HEADER___COST_APPLI_LINE_DRAWING_VECTORIZATION__

#include<random>
struct ini_data_cost_line_drawing_vectorization
{
	static std::random_device rd;
	static std::mt19937 gen;//x,y,color,distance
	static std::uniform_int_distribution<int> op_selector;
	template<typename SA>
	static void operator_label(SA* sa)
	{
		const int rnd = op_selector(gen) % 3;
		switch (rnd)
		{
			case 0:sa->operator_label_edge(); break;
			case 1:sa->operator_merge_curve(); break;
			case 2:sa->operator_split_curve(); break;
		}
	}
};

#endif  __HEADER___COST_APPLI_LINE_DRAWING_VECTORIZATION__

