#ifndef __Texture_QT_HEADER__
#define __Texture_QT_HEADER__

#include"Texture.hpp"
//#include<QtOpenGL/QtOpenGL>

class Texture_qt : public base_texture
{
protected:
public:
	virtual bool loadTexture(const std::string &path);
	virtual bool save_texture(const std::string& name, unsigned char* data, const int& w, const int& h);
	static bool save_data(const std::string& name, unsigned char* data, const int& w, const int& h);
	static bool save_data_mono(const std::string& name, unsigned char* data, const int& w, const int& h);
	Texture_qt();
	Texture_qt(const std::string& path);
	Texture_qt(const GLuint id);
	Texture_qt(const glm::vec2& size);


	virtual ~Texture_qt();

};

#endif
