#ifndef AUGMENTED_MESH_HEADER
#define AUGMENTED_MESH_HEADER
#include "object.h"
#include"augmented_mesh.h"


class AugmentedMesh_obj : public base_object<AugmentedMesh_obj>
{
	public:
		AugmentedMesh_obj(VAO* ptr_vao, AugmentedMesh& _data) : base_object<AugmentedMesh_obj>(ptr_vao), data(_data){}
		virtual ~AugmentedMesh_obj(){}
		void normal_data(std::string& name, std::vector<glm::vec3>&);
		void color_data(std::string& name, std::vector<glm::vec4>& _data);
		void vertex_data(std::string& name, std::vector<glm::vec3>&);
		void facet_data(std::string& name, std::vector<glm::uvec3>&);
		inline void draw_2(const glm::mat4& scene)const
		{
			glDrawElements(GL_TRIANGLES, GLsizei(data._face_vec.size() * 3), GL_UNSIGNED_INT, 0);
		}
	protected:
		AugmentedMesh& data;
};

#endif


