#pragma once

#ifndef ___TEXT__HEADER___
#define ___TEXT__HEADER___

#include"util_define.h"
#include<QtOpenGL/QGLWidget>

struct base_txt
{
	float x,y;
	std::string str;
	
	base_txt(float _x, float _y, const std::string& _s) : x(_x), y(_y), str(_s)
	{
	}
	base_txt(double _x, double _y, const std::string& _s) : x(_x), y(_y), str(_s)
	{
	}
	base_txt(double _x, double _y, const char* _s) : x(_x), y(_y), str(_s)
	{
	}
};
class Text
{
public:
	std::list<base_txt> lst;
	glm::dvec2 offset;
	glm::vec2 t;
	float s;
	void draw(QGLWidget* mw)
	{
		float w = mw->width();
		float h = mw->height();
		//std::cout << "text" << std::endl;
		glColor3f(0.0, 0.0, 0.0);
		glDisable(GL_DEPTH_TEST);
		for (const base_txt& bt : lst)
		{
		//	glm::vec2 pos = mw->coordinate_gl_to_window({ bt.x, bt.y });
		//	std::cout << w*(s * (bt.x - 0.5 + 0.5*t.x )+ 0.5) << "   " << h*(s * (bt.y - 0.5 -0.5* t.y) + 0.5) << std::endl;
			mw->renderText(w*(s * (bt.x - 0.5 + 0.5*t.x) + 0.5), h*(s * (bt.y - 0.5 - 0.5* t.y) + 0.5), bt.str.c_str());
		}
		glEnable(GL_DEPTH_TEST);
	}
};


//m_last_pos_vec2_in_sketch_coord = glm::vec2((m_last_pos.x()*1.0 / width() - 0.5f) / s + 0.5f - 0.5f*t.x,
//	(m_last_pos.y()*1.0 / height() - 0.5f) / s + 0.5f + 0.5*t.y);


#endif

